/* main */

void input(int run_option, char *ccmfile);
void define(void);
void obtain(void);


/* define */

void recursiveClusteringFunction(int (*configuration)[5], 
				 int length, 
				 int maxorder, 
				 int &NumberConnected);

int findDescriptorIndex(int *descriptor, int NumberConnected);

/* bookKeeping */

int seconds(void);
void initDivisors(void);

int findDescriptorOfCluster(int order,
             int (*configuration)[5], int *descriptor); // new 0606

void printOutDescriptor(int *descriptor);

void printOutClusterFromDescriptor(int *descriptor);

void printOutConfig(int (*configuration)[5], int length);

void symmetryGroup(int switchVariable, int order,
		   int (*configuration)[5],  // changed by Joerg Jun06
		   int (*tempConfiguration)[5]); // changed by Joerg Sep05


void findCartesiansFromGeneralisedPosition(double &x, double &y, double &z, 
					   int *configuration);

// null x y z uc
void findConfigurationToDescriptor(int *descriptor, int (*config)[5], 
         int order); 

int findClusterFromDescriptor(int *descriptor, int (*configuration)[5]);

void   binary(int index,  int length, int *spin);
void  trimary(int index1, int index2, int index3, int length, int *spin);
void quartary(int index1, int index2, int index3, int length, int *spin);

/* new routines for higher spin + define */

int findDescriptorIndex2(int *descriptor,int numberElements);
void updateDescriptors2(int *descriptor,int numberElements);
void findFundamentalSpinConfigurations(void);
void findSpinState(int *descriptor, int *spinState);

/* collect */

void collect(void);

/* solve */

void solve(void);
void usrfun(int n, double *fvec, double **fjac, double *x, 
		     int iterations);

void definePointsInBT(void);
